﻿* Encoding: UTF-8.
*Procrustes analysis
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_PROCRUST*/***************************************************************************.
define !KO_procrust(fit= !charend('/') /target= !charend('/') /center= !charend('/') /scale= !charend('/') /rotat= !charend('/')
                /norefl= !charend('/') /isoscale= !charend('/') /perm= !charend('/') /save= !charend('/') /output= !charend('/'))
!if (!perm<>!null) !then
-set mxloops 1000000.
!ifend
matrix.
get a /vari= !fit /names= fnam.
get b /vari= !target /names= tnam.
comp fnam2= {' ',fnam}.
comp tnam2= {' ',tnam}.
comp n= nrow(a).
comp ok= 1.
!if (!rotat='ORTPERP') !then
-do if ncol(a)>ncol(b).
- comp ok= 0.
- print /title '>ERROR. При ROTAT=ORTPERP число столбцов в целевой конфигурации'.
- print /title ' должно быть не меньше чем в подгоночной конфигурации.' /space= 0.
-end if.
!ifend
!if (!rotat='SKEWORT') !then
-do if ncol(a)<ncol(b).
- comp ok= 0.
- print /title '>ERROR. При ROTAT=SKEWORT число столбцов в подгоночной конфигурации'.
- print /title ' должно быть не меньше чем в целевой конфигурации.' /space= 0.
-end if.
!ifend
do if ok.
-print /title 'ПРОКРУСТОВ АНАЛИЗ ДЛЯ ДВУХ КОНФИГУРАЦИЙ'.
-comp p= rmax({ncol(a),ncol(b)}).
-comp pointnum= t({1:n}).
-do if ncol(a)<p.
- comp a= {a,make(n,p-ncol(a),0)}.
-else if ncol(b)<p.
- comp b= {b,make(n,p-ncol(b),0)}.
-end if.
 !if (!center='YES') !then
- comp a= a-kroneker(csum(a)/n,make(n,1,1)).
- comp b= b-kroneker(csum(b)/n,make(n,1,1)).
- print /title 'Центрация обеих конфигураций к Mean=0 сделана до прокрустова вращения.'.
 !ifend
 !if (!scale='YES') !then
- comp meanss= (mssq(a)+mssq(b))/2.
- comp a= a*sqrt(meanss/mssq(a)).
- comp b= b*sqrt(meanss/mssq(b)).
- print /title 'Масштабир-е обеих конфигураций к SS=(SS1+SS2)/2 сделано до прокрустова вращения.'.
 !ifend
 !if (!rotat='NONE') !then
- print /title '>NOTE. Заказано подавить прокрустого вращение.'.
 !ifend
 !if ((!rotat='ORTHO' !or !rotat=!null) !and !norefl='YES') !then
- print /title '>NOTE. Заказано подавить возможное отражение во время вращения.'.
 !ifend
 !if (!rotat='ORTPERP' !or !rotat='SKEWORT') !then
- print /title '>NOTE. Заказано неортогональное вращение.'.
 !ifend
 !if (!perm<>!null) !then
- comp oss= make(1,!perm,0).
- comp ptss= make(n,!perm,0).
- comp dimss= make(p,!perm,0).
 !ifend
-loop perm= 0 to !if (!perm=!null) !then 0 !else !perm !ifend.
- do if perm>0.
-  comp b(grade({uniform(n,1),b}(:,1)),:)= b.
- end if.
  !if (!rotat='NONE') !then
-  comp ab= a.
  !else
   !if (!rotat='ORTHO' !or !rotat=!null) !then !let !rot= 'Матрица ортогонального вращения:'
-   call svd(t(b)*a,u,s,v).
    !if (!norefl='YES') !then
-    do if not det(v*t(u)).
-     comp v(:,p)= -v(:,p).
-     comp s(p,p)= -s(p,p).
-    end if.
    !ifend
-   comp rm= v*t(u).
-   comp ab= a*rm.
    !if (!isoscale='YES') !then
-    comp sf= trace(s)/trace(sscp(a)).
-    comp ab= ab*sf.
    !ifend
   !else
-   comp rm= ginv(sscp(a))*t(a)*b.
    !if (!rotat='ORTPERP') !then !let !rot= 'Матрица ортогонального-в-неортогональное[перпенд. коорд.] вращения:'
-    comp rm= rm/kroneker(sqrt(cssq(rm)),make(p,1,1)).
    !else !let !rot= 'Матрица неортогонального[косые коорд.]-в-ортогональное вращения:'
-    comp rm= rm/kroneker(sqrt(rssq(rm)),make(1,p,1)).
    !ifend
-   comp ab= a*rm.
   !ifend
  !ifend
- comp res= b-ab.
- do if perm=0.
-  comp oss0= mssq(res).
-  comp ptss0= rssq(res).
-  comp dimss0= t(cssq(res)).
   !if (!output='LONG') !then
-   print {pointnum,a} /title 'Подгоночная конфигурация:' /cnam= fnam2 /format f8.4.
-   print {pointnum,b} /title 'Целевая конфигурация:' /cnam= tnam2 /format f8.4.
    !if (!rotat<>'NONE') !then
-    print rm /title !quote(!rot) /rnam= fnam /cnam= tnam /format f8.4.
     !if (!rotat<>'ORTHO' !and !rotat<>!null) !then
-     print cssq(rm) /title 'Ее сумма квадратов в столбцах:' /cnam= tnam /format f8.4.
-     print rssq(rm) /title 'Ее сумма квадратов в рядах:' /rnam= fnam /format f8.4.
     !else
      !if (!norefl<>'YES') !then
-      print det(rm) /title 'Ее определитель (-1 если присутствовало отражение, +1 иначе):' /format f3.
      !ifend
     !ifend
     !if (!isoscale='YES' !and (!rotat='ORTHO' !or !rotat=!null)) !then
-     print sf /title 'Фактор изотропного масштабирования, сделанного после вращения:' /format f8.4.
     !ifend
    !ifend
-   print {pointnum,ab} /title 'Подогнанная подгоночная конфигурация:' /cnam= tnam2 /format f8.4.
-   print {pointnum,res} /title 'Остатки (Целевая минус Подогнанная):' /cnam= tnam2 /format f8.4.
-   print (msum(res)/(n*p)) /title 'Средняя остатков:' /format f8.4.
   !ifend
-  print /title 'Статистики подгонки ниже:'.
-  print /title '   RMSerror - Корень из среднего квадратного остатка' /space= 0.
-  print /title '   IDc - Коэффициент идентичности' /space= 0.
-  print /title '   PRc - Коэффициент пропорциональности' /space= 0.
-  print {sqrt(oss0/(n*p)),2*trace(t(b)*ab)/(mssq(b)+mssq(ab)),trace(t(b)*ab)/sqrt(mssq(b)*mssq(ab))} /title 'Общая подогнанность:' /clab= 'RMSerror' 'IDc' 'PRc' /format f8.4.
-  print {pointnum,sqrt(ptss0/p),2*rsum(b&*ab)&*(rssq(b)+rssq(ab)>0)/(rssq(b)+rssq(ab)+(rssq(b)+rssq(ab)=0)),rsum(b&*ab)&*(rssq(b)&*rssq(ab)>0)/sqrt(rssq(b)&*rssq(ab)+(rssq(b)&*rssq(ab)=0))}
      /title 'По-точечная подогнанность:' /clab= ' ' 'RMSerror' 'IDc' 'PRc' /format f8.4.
-  print {sqrt(dimss0/n),t(2*csum(b&*ab)&*(cssq(b)+cssq(ab)>0)/(cssq(b)+cssq(ab)+(cssq(b)+cssq(ab)=0))),t(csum(b&*ab)&*(cssq(b)&*cssq(ab)>0)/sqrt(cssq(b)&*cssq(ab)+(cssq(b)&*cssq(ab)=0)))}
      /title 'По-измеренная подогнанность:' /rnam= tnam /clab= 'RMSerror' 'IDc' 'PRc' /format f8.4.
-  do if any((rssq(b)+rssq(ab))=0) or any((cssq(b)+cssq(ab))=0).
-   print /title '>WARNING. Некоторые IDc не могли быть посчитаны из-за нулевого знаменателя.'.
-   print /title '          Они напечатаны как если бы они были 0.' /space= 0.
-  end if.
-  do if any((rssq(b)&*rssq(ab))=0) or any((cssq(b)&*cssq(ab))=0).
-   print /title '>WARNING. Некоторые PRc не могли быть посчитаны из-за нулевого знаменателя.'.
-   print /title '          Они напечатаны как если бы они были 0.' /space= 0.
-  end if.
   !if (!save='YES') !then
-   write {'rename ','vari ','(all='} /outfile= 'temp_KO_procrust.sps' /field 1 to 24 /format a8.
-   loop i= 1 to ncol(tnam).
-    write 't_' /field 2 to 12 /format a2 /hold.
-    write tnam(i) /field 2 to 12 /format a8.
-   end loop.
-   loop i= ncol(tnam)+1 to p.
-    write 't_' /field 2 to 12 /format a2 /hold.
-    write i /field 2 to 12 /format n6.
-   end loop.
-   loop i= 1 to ncol(tnam).
-    write 'f_' /field 2 to 12 /format a2 /hold.
-    write tnam(i) /field 2 to 12 /format a8.
-   end loop.
-   loop i= ncol(tnam)+1 to p.
-    write 'f_' /field 2 to 12 /format a2 /hold.
-    write i /field 2 to 12 /format n6.
-   end loop.
-   write ').' /field 2 to 4 /format a2.
-   save {b,ab} /outfile= *.
   !ifend
- else.
-  comp oss(perm)= mssq(res).
-  comp ptss(:,perm)= rssq(res).
-  comp dimss(:,perm)= t(cssq(res)).
- end if.
-end loop.
-release a,b,ab,res.
 !if (!perm<>!null) !then
- comp oss(grade(oss))= oss.
- loop perm= 1 to !perm if oss(perm)<=oss0.
- end loop.
- comp oss0= (perm-1)/!perm.
- loop i= 1 to n.
-  comp ptss(i,grade(ptss(i,:)))= ptss(i,:).
-  loop perm= 1 to !perm if ptss(i,perm)<=ptss0(i).
-  end loop.
-  comp ptss0(i)= (perm-1)/!perm.
- end loop.
- loop i= 1 to p.
-  comp dimss(i,grade(dimss(i,:)))= dimss(i,:).
-  loop perm= 1 to !perm if dimss(i,perm)<=dimss0(i).
-  end loop.
-  comp dimss0(i)= (perm-1)/!perm.
- end loop.
- print /title 'Монте-карловский перестановочный тест ниже'.
- print /title !quote(!conc('(',!perm,' случайных перестановок среди точек целевой конфигурации сделано):')) /space= 0.
- print /title '   Sig. - монте-карловская значимость (1-стор.)' /space= 0.
- print /title '   LBound - нижняя граница ее 99% доверительного интервала' /space= 0.
- print /title '   UBound - верхняя граница ее 99% доверительного интервала' /space= 0.
- comp ci= 2.5758*sqrt(oss0&*(1-oss0)/!perm).
- comp lo= oss0-ci.
- comp up= oss0+ci.
- print {oss0,lo&*(lo>=0),up&*(up<=1)+(up>1)} /title 'Общая значимость:' /clab= 'Sig.' 'LBound' 'UBound' /format f8.4.
- comp ci= 2.5758*sqrt(ptss0&*(1-ptss0)/!perm).
- comp lo= ptss0-ci.
- comp up= ptss0+ci.
- print {pointnum,ptss0,lo&*(lo>=0),up&*(up<=1)+(up>1)} /title 'По-точечная значимость:' /clab= ' ' 'Sig.' 'LBound' 'UBound' /format f8.4.
- comp ci= 2.5758*sqrt(dimss0&*(1-dimss0)/!perm).
- comp lo= dimss0-ci.
- comp up= dimss0+ci.
- print {dimss0,lo&*(lo>=0),up&*(up<=1)+(up>1)} /title 'По-измеренная значимость:' /rnam= tnam /clab= 'Sig.' 'LBound' 'UBound' /format f8.4.
 !ifend
end if.
end matrix.
!if (!save='YES') !then
-include file 'temp_KO_procrust.sps'.
-var lev all (sca).
-erase file 'temp_KO_procrust.sps'
!ifend
!enddefine.
